events.listen('recipes', event => {

  event.shaped(item.of('rangedpumps:pump', 1), [
    'OTO',
    'LMW',
    'OPO'
  ], {
    O: '#forge:obsidian',
    T: 'mekanism:basic_fluid_tank',
    L: 'minecraft:lava_bucket',
    M: '#forge:machineframe/basic',
    W: 'minecraft:water_bucket',
    P: 'mekanism:basic_mechanical_pipe'
  })

  event.shaped(item.of('globalxp:xp_block', 1), [
    'ABA',
    'ACA',
    'ADA'
  ], {
    A: 'minecraft:iron_bars',
    B: 'engineerstools:charged_lapis_squeezer',
    C: 'mekanism:pellet_antimatter',
    D: 'darkutils:ender_hopper'
  })

  event.shaped(('angelring:itemdiamondring'), [
    'NBN',
    'BEB',
    'NBN'
  ], {
    E: 'mekanism:module_gravitational_modulating_unit',
    B: '#forge:storage_blocks/diamond',
    N: '#forge:gems/diamond'
  })

  event.shaped(('angelring:itemdiamondring'), [
    'NBN',
    'BEB',
    'NBN'
  ], {
    E: 'draconicevolution:draconic_flight_module',
    B: '#forge:storage_blocks/diamond',
    N: '#forge:gems/diamond'
  })

  event.shaped(item.of('engineerstools:material_box', 1), [
    'AAA',
    'BCB',
    'BBB'
  ], {
    A: 'minecraft:string',
    B: '#forge:ingots/iron',
    C: 'ironchest:iron_chest'
  })

  event.shaped(item.of('pneumaticcraft:compressed_iron_gear', 1), [
    ' A ',
    'ABA',
    ' A '
  ], {
    A: '#forge:ingots/compressed_iron',
    B: '#forge:ingots/iron'
  })

  event.shaped(item.of('xnet:controller', 1), [
    'EFE',
    'CDC',
    'EAE'
  ], {
    A: '#forge:ingots/gold',
    C: '#forge:dusts/redstone',
    D: 'rftoolsbase:machine_frame',
    E: '#forge:ingots/iron',
    F: 'computercraft:computer_advanced'
  })

  event.shaped(item.of('torchmaster:megatorch', 1), [
    'ABC',
    'DED',
    'FEF'
  ], {
    A: item.of('minecraft:potion', {Potion:"minecraft:strong_regeneration"}),
    B: 'minecraft:soul_campfire',
    C: item.of('minecraft:potion', {Potion:"minecraft:strong_healing"}),
    D: '#forge:gems/diamond',
    E: 'minecraft:hay_block',
    F: '#forge:storage_blocks/gold'
  })

  event.shaped(item.of('torchmaster:feral_flare_lantern', 1), [
    ' A ',
    'BCB',
    ' A '
  ], {
    A: '#forge:ingots/gold',
    B: 'minecraft:lantern',
    C: '#forge:dusts/glowstone'
  })

  event.shaped(item.of('minecraft:soul_campfire', 1), [
    ' A ',
    'ABA',
    'CCC'
  ], {
    A: '#forge:rods/blaze',
    B: '#minecraft:soul_fire_base_blocks',
    C: '#minecraft:logs'
  })

  event.shaped(item.of('javd:portal_block', 1), [
    'ADA',
    'BCB',
    'ABA'
  ], {
    A: 'minecraft:end_stone_bricks',
    B: 'torchmaster:megatorch',
    C: 'minecraft:end_crystal',
    D: 'minecraft:ender_pearl'
  })

  event.shaped(item.of('jamd:mine_portal_block', 1), [
    'ADA',
    'BCB',
    'ABA'
  ], {
    A: 'minecraft:end_stone_bricks',
    B: 'torchmaster:megatorch',
    C: 'minecraft:diamond_pickaxe',
    D: 'minecraft:ender_pearl'
  })

  event.shaped(item.of('pamhc2foodcore:rolleritem', 1), [
    '  A',
    ' B ',
    'A  '
  ], {
    A: '#forge:rods/wooden',
    B: '#minecraft:logs'
  })

  event.shaped(('engineersdecor:metal_bar'), [
    '  A',
    ' A ',
    'A  '
  ], {
    A: '#forge:ingots/steel'
  })

  event.shaped(('tesseract:tesseract'), [
    'ACA',
    'BDB',
    'ACA'
], {
    A: '#forge:ingots/refined_obsidian',
    B: 'mekanism:ultimate_control_circuit',
    C: '#thermal:glass/hardened',
    D: 'mekanism:teleportation_core'
})

  event.shaped(('entangled:block'), [
    'FOF',
    'OCO',
    'FOF'
  ], {
    F: 'fluxnetworks:flux_core',
    O: 'minecraft:obsidian',
    C: '#forge:chests/wooden'
  })

  event.shaped(('minecraft:end_crystal'), [
    'GGG',
    'GSG',
    'GTG'
  ], {
    G: 'minecraft:glass',
    S: 'minecraft:nether_star',
    T: 'minecraft:ghast_tear'
  })

  event.shapeless(('2x immersiveengineering:storage_uranium'), ['mekanism:block_uranium', 'mekanism:block_uranium'])
  event.shapeless(('create:scoria'), ['byg:scoria_stone'])
  event.shapeless(('byg:scoria_stone'), ['create:scoria'])
  event.shapeless(('4x chisel:charcoal/raw'), ['minecraft:charcoal', 'minecraft:charcoal', 'minecraft:charcoal', 'minecraft:charcoal'])

  const multiSmelt = (output, input) => {
    event.smelting(output, input)
    event.blasting(output, input)
  }

  multiSmelt('eidolon:enchanted_ash', 'minecraft:bone_meal')
})
